<template>
  <div>
    <v-row v-show="isVisible">
      <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
        <div id="histoChart" class="charts" ref="histoChart"></div>
      </v-col>
    </v-row>
  </div>
</template>
<style scoped>
.charts {
  width: 100%;
  height: 300px;
}
</style>
<script>
import htmlToImage from "html-to-image";
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
import am4themes_material from "@amcharts/amcharts4/themes/material";
import axios from "axios";
let chart;
export default {
  name: "Component-Histograma",
  props: {
    isLoading: Function,
    methodsSemaforoParent: Object,
    globalFiltersParent: Object
  },
  data() {
    return {
      chart: null,
      methodsSemaforo: null,
      globalFilters: null,
      dataHistograma: [],
      isVisible: true,
      chartCreated: false
    };
  },
  computed: {
    isVisibleHistograma() {
      if (
        this.globalFilters &&
        this.globalFilters.final_filters.nivel_geografico == 0
      ) {
        return false;
      } else {
        return true;
      }
    }
  },
  methods: {
    listenSearchConsulta(globalFilters) {
      let filters = JSON.parse(JSON.stringify(globalFilters));
      if (filters.final_filters.nivel_geografico > 0) {
        this.globalFilters = globalFilters;
        this.getHistograma();
        this.isVisible = true;
      } else {
        this.isVisible = false;
      }
    },
    getHistograma() {
      this.isLoading(true);
      const self = this;
      const contentFiltros = {
        filtros: this.globalFilters.final_filters
      };
      axios
        .post(
          "franquicia/dashboard/secure/grafico/get/histograma/nivel",
          contentFiltros
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setHistograma(data);
              }
            } else {
              self.setHistograma([]);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoading(false);
        });
    },
    setHistograma(dataHistograma) {
      if (dataHistograma && dataHistograma.length > 0) {
        dataHistograma = dataHistograma.sort(function(a, b) {
          if (a.calificacion_final < b.calificacion_final) {
            return -1;
          }
          if (b.calificacion_final < a.calificacion_final) {
            return 1;
          }
          return 0;
        });
      }
      this.dataHistograma = dataHistograma;
      this.drawChart();
    },
    drawChart() {
      chart.data = this.dataHistograma;
    },
    initChart() {
      am4core.ready(function() {
        const config = {
          data: null,
          xAxes: [
            {
              type: "CategoryAxis",
              dataFields: {
                category: "calificacion_final"
              },
              title: {
                text: "Calificaciones"
              },
              renderer: {
                grid: {
                  strokeOpacity: 0
                },
                minGridDistance: 20
              }
            }
          ],
          yAxes: [
            {
              type: "ValueAxis",
              title: {
                text: "Frecuencia"
              },
              renderer: {
                grid: {
                  strokeOpacity: 0
                }
                //minGridDistance: 40
              }
            }
          ],
          logo: {
            properties: {
              hidden: true
            }
          },
          scrollbarX: {
            type: "Scrollbar"
          },
          scrollbarY: {
            type: "Scrollbar"
          },
          series: [
            {
              type: "ColumnSeries",
              dataFields: {
                valueY: "frecuencia",
                categoryX: "calificacion_final"
              },
              name: "Histograma",
              columns: {
                tooltipText: "Calificacion: {categoryX}\n Frecuencia: {valueY}",
                stroke: "#b2b2b2",
                fill: "#b2b2b2"
              }
            }
          ]
        };
        chart = am4core.createFromConfig(
          config,
          document.getElementById("histoChart"),
          am4charts.XYChart
        );
        chart.cursor = new am4charts.XYCursor();
        chart.cursor.maxTooltipDistance = 10;
      });
    }
  },
  mounted() {
    this.$root.$on("searchconsulta", this.listenSearchConsulta);
    this.initChart();
  },
  created() {
    this.methodsSemaforo = this.methodsSemaforoParent;
    this.globalFilters = this.globalFiltersParent;
    if (this.globalFilters && this.methodsSemaforo) {
      this.getHistograma();
    }
  },
  beforeDestroy() {
    if (chart) {
      chart.dispose();
    }
  }
};
</script>
